/*
   File: dcg_parser2.c
   Parses all files indicated by the argument string

   CVSID: "$Id: dcg_parser2.c,v 1.9 2005/02/24 14:37:58 marcs Exp $"
*/

/* standard includes */
#include <stdio.h>
#include <string.h>

/* Conditional inclusion to define MAXPATHLEN */
#ifndef WIN32
#include <sys/param.h>
#endif
#ifndef MAXPATHLEN
#define MAXPATHLEN 256
#endif

/* libdcg includes */
#include <dcg.h>
#include <dcg_error.h>

/* local includes */
#include "dcg_code.h"
#include "dcg_lex.h"
#include "dcg_parser2.h"

static FILE *try_open (char *basename)
	{ FILE *new;
	  char fname[MAXPATHLEN + 1];
	  sprintf (fname, "%s.dcg", basename);
	  if ((new = fopen (fname, "r")))
	     hint ("parsing %s...", fname);
	  else
	     { sprintf (fname, "%s", basename);
	       if ((new = fopen (fname, "r")))       
		  hint ("parsing %s...", fname);
	       else panic ("could not open %s", fname);
	     };
	  return (new);
	};

static void parse_imported_definitions (string iname, string_list include_path)
	{ FILE *new;
	  char fname[MAXPATHLEN + 1];
	  int ix;
	  for (ix = 0; ix < include_path -> size; ix++)
	     { sprintf (fname, "%s/%s.def", include_path -> array[ix], iname);
	       if ((new = fopen (fname, "r")))
	          { hint ("parsing definitions from %s.def...", iname);
		    init_lex (new);
		    pdcg_parse ();
		    fclose (new);
		    return;
		  };
	     };
	  panic ("could not locate %s[.def]", iname);
	};

#define STDDEF "dcg"
void parse (char *basename, string_list include_path)
	{ FILE *f = try_open (basename);
	  int ix;
	  imp_types = new_type_list ();
	  all_defs = new_def_list ();
	  all_stats = new_stat_list ();
	  init_lex (f);
	  pdcg_parse ();
	  fclose (f);
	  for (ix = 0; ix < all_stats -> size; ix++)
	     { stat s = all_stats -> array[ix];
	       if (s -> tag == TAGImport)
	          parse_imported_definitions (s -> Import.imp, include_path);
	     };
	  parse_imported_definitions (STDDEF, include_path);
	};
