/*
   File: options.h
   Defines flags and parameters of the datastructure generator

   CVS ID: "$Id: options.h,v 1.4 2005/02/24 15:05:11 marcs Exp $"
*/
#ifndef IncOptions
#define IncOptions

/* libdcg includes */
#include <dcg.h>
#include <dcg_string.h>

/* local include */
#include "dcg_code.h"

/* Exported flags */
extern int coding_flag;
extern int saving_flag;
extern int loading_flag;
extern int xformer_flag;
extern int code_transput;
extern int code_rdup;
extern int code_extra_tags;
extern int code_pretty_print;

/* Exported parameters and search paths */
extern string_list ex_names;
extern string_list include_path;
extern string xformer_ptype;
extern string xformer_pname;
extern string basic_types;

/* Exported routines to parse the command line and report version */
void init_options ();
void scan_options (int *argc, char **argv);
void scan_basename (int argc, char **argv, char *basename);
void try_report_version ();

#endif /* IncOptions */
