/*
   File: dcg_arith.c
   Defines arithmetic support

   CVS ID: "$Id: dcg_arith.c,v 1.5 2005/02/24 14:59:35 marcs Exp $"
*/

/* local includes */
#include "dcg.h"
#include "dcg_arith.h"

int ilog2 (int nr)
	{ int i=0;
	  while ((1<<i) < nr) i++;
	  return (i);
	};

int ilog10 (int n)
	{ int i, z=1;
	  for (i=0; z<n; i++) z *= 10;
	  return (i);
	};

int ipower (int nr, int exp)
	{ register int z=1, b0 = nr, n0 = exp;
	  while (n0!=0)
	     { if (odd (n0)) z *= b0;
	       n0 >>= 1;
	       b0 *= b0;
	     };
	  return (z);
	};

int imod (int l, int r)
	{ register int q = l / r;
	  if (q < 0) q--;
	  return (l - q * r);
	};

int irem (int l, int r)
	{ register int q = l / r;
	  return (l - q * r);
	};
